Subject: Re: [RFC PATCH] net: phy: integrate reset-after-clock quirk into phy_init_hw

From: "Russell King (Oracle)" <[email-masked]>
Date: Wed, 28 Jan 2026 13:58:17 +0000

On Wed, Jan 28, 2026 at 02:33:24PM +0100, Michael Nazzareno Trimarchi wrote:
> Hi Andrew
> 
> On Wed, Jan 28, 2026 at 2:25 PM Andrew Lunn <[email-masked]> wrote:
> >
> > On Wed, Jan 28, 2026 at 10:46:41AM +0100, Michael Trimarchi wrote:
> > > The current implementation of phy_reset_after_clk_enable requires MAC drivers
> > > (like fec_main.c) to manually track PHY probing states and trigger resets
> > > at specific points in their clock management flow and was created just for a SoC
> > > vendor.
> >
> > We try to keep workarounds for specific SoC vendors out of the core,
> > when possible. It just makes the core more complex for an edge case
> > which most people don't care about. It is better to hide the
> > complexity away in the driver which needs it.
> 
> We should not merge things in the core that are for one Soc and
> after d65af21842f8a7821fc3b28dc043c2f92b2b312c, I need to anyway to do:
> 
> net: phy: smsc: Fix functionality of lan8710 in combination with NXP fec
> 
> Revert "net: phy: smsc: LAN8710/20: remove PHY_RST_AFTER_CLK_EN flag"
> d65af21842

That commit is an example of a poor commit description. It doesn't
describe the problem, nor which hardware this affects, so when we end
up with this kind of situation, we're lacking the context behind why
the change was made.

So, how do we know that reverting that commit is not going to cause a
regression for whatever platform the patch was proposed for?

If you read the preceeding commit (which is referenced by the commit
you intend to revert) itgives more information about the problem, and
I would expect that reverting it will cause a regression with
interrupts.

Adding Marco to this thread for comment.

Also, maybe you could clearly state what the issue that you are trying
to address - why do you need special reset handling for the combination
of FEC + this PHY. Consider including that description in the commit
message for any proposed solution so that - as is the case here looking
back at Macro's commit - we can see _why_ the change is being made.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!